;
; Compile with FASM (http://fasm.sourceforge.net)
;
; Keygenme v1 by you_known[FCG] - keygen coded by bundy (c) 2oo3
;

format PE GUI 4.0
entry start

include '%include%\win32a.inc'


GENERATE	= 0   ; if = 1 a Generate button is displayed and have to
		      ; be pressed to generate serial number
  MAXCHARS	= 30  ; (+1 for terminating zero)  should be enough

  ED_NAME	= 101
  ED_SERIAL	= 102
  BUT_GENERATE	= 103
  BUT_ABOUT	= 104

  DLG_MAIN	= 100
  ID_ICON	= 10


section '.code' code readable executable

  start:
	invoke	GetModuleHandle,0
	mov	[hinstance],eax
	invoke	DialogBoxParam,eax,DLG_MAIN,HWND_DESKTOP,DialogProc,0
	invoke	ExitProcess,0

proc DialogProc,hwnddlg,msg,wparam,lparam
	enter

	push	ebx esi edi
	cmp	[msg],WM_INITDIALOG
	je	wminitdialog
	cmp	[msg],WM_COMMAND
	je	wmcommand
	cmp	[msg],WM_CLOSE
	je	wmclose
	jmp	notprocessed
wminitdialog:
	invoke	LoadIcon,[hinstance],ID_ICON		; LoadIcon
	invoke	SendMessage,[hwnddlg],WM_SETICON,1,eax	; Show icon
	invoke	SendDlgItemMessage, [hwnddlg], ED_NAME, EM_SETLIMITTEXT, MAXCHARS, 0
							; set limit
	invoke	SetDlgItemText, [hwnddlg], ED_NAME, bundy	; set my name
	jmp	processed
  wmcommand:
	mov	eax, [wparam]
	cmp	[lparam],0
	je	notprocessed
if GENERATE=0
	mov	edx,[wparam]
	shr	edx,16
	cmp	ax,ED_NAME
	jne	about
	cmp	dx,EN_CHANGE	; edit box change?
	jne	notprocessed
	stdcall CalculateSerial,[hwnddlg]   ; CalculateSerial
	jmp	processed
end if
    about:
	cmp	ax,BUT_ABOUT
if GENERATE=1
	jne	generate
else
	jne	processed
end if
	invoke	MessageBox,[hwnddlg],about_text,about_capt,MB_OK+MB_ICONINFORMATION
				; about box
	jmp	processed
if GENERATE=1
    generate:
	cmp	ax,BUT_GENERATE
	jne	notprocessed
	stdcall CalculateSerial,[hwnddlg]
	jmp	processed
end if
  wmclose:
	invoke	EndDialog,[hwnddlg],0
  processed:
	mov	eax,1
	jmp	finish
  notprocessed:
	xor	eax,eax
;	 jmp	 finish
  finish:
	pop	edi esi ebx
	return

proc CalculateSerial,hwnd

	enter

	invoke	GetDlgItemText, [hwnd], ED_NAME, name, MAXCHARS+1
	test	eax,eax 	; at least 1?
	jnz	continue
	invoke	SetDlgItemText, [hwnd], ED_SERIAL, AtLeast1
				; Enter at least 1 char!
	jmp	quit		; quit proc
   continue:
	mov	edi, temp_serial
	mov	esi, name
	xor	ebx, ebx		; how many bytes we wrote
	push	6
	pop	ecx			; ecx = 6
	xor	edx, edx
	div	ecx			; length / 6 = eax, length % 6 = edx
	mov	ecx, eax		; save how many full 6 bytes we have
	test	ecx, ecx
	je	less_than_6bytes

; ---- process 6 bytes save -----
   next_6bytes:
	mov	ax, 0FF02h		; 02, [FF - I use it to fuck with this 2nd delete in ECExtractInbeddedString]
	stosw				; write it
	push	ecx
	push	6
	pop	ecx
	rep	movsb			; copy 6 bytes
	pop	ecx
	xor	eax, eax
	stosb				; put 0
	add	ebx, 2+6+1
	dec	ecx
	jnz	next_6bytes
   less_than_6bytes:
	test	edx, edx
	je	convert_serial		; if remainder is 0 just to convert_serial
	push	6
	pop	ecx
	sub	ecx, edx		; ecx = 6-length(rest of name), edx = length(rest of name)
	xchg	ecx, edx		; edx <-> ecx
	mov	al, 02
	stosb				; 02
	mov	al, dl
	stosb				; 6-length(rest of name)
	rep	movsb			; copy rest of name
	xor	eax, eax
	mov	ecx, edx
	rep	stosb			; put zeros to fill to length 6
	stosb				; put terminating zero!
	add	ebx, 2+6+1

   convert_serial:
; ---- make base 64 serial from 256 base
	mov	esi, temp_serial
	mov	edi, serial
	mov	ecx, ebx
	xor	eax, eax

   __b64e_loop: 			; lightly modified version of roy|fleur's b64.asm
	lodsd				; I could make it too .. but I'm lazy ... :-)
	xchg	ah,al
	rol	eax,16			; change order
	xchg	ah,al
	dec	esi			; dec esi ... we read 4 bytes but wanted 3 ... 1 back
	mov	ebx,eax 		; save eax in ebx
	rol	ebx,6
	mov	dl,4			; we will make 4 base64 bytes from 3 base256
@@:	mov	eax,ebx
	rol	ebx,6
	and	eax,0111111b
	mov	al,byte [base64tab+eax] ; get corresponding char from table
	stosb				; store it
	dec	dl
	jnz	@b			; all 4 chars?
	sub	ecx,3
	jg	__b64e_loop		; are there more?
	xor	al, al
	stosb				; terminating zero

; ---- send correct serial to dialog ----
	invoke	SetDlgItemText, [hwnd], ED_SERIAL, serial
   quit:
	return

section '.data' data readable writeable

  bundy db 'bundy',0	; send this at start to edit box :-)
  AtLeast1 db 'Enter at least 1 char!',0	; Enter something

  about_capt db 'About',0
  about_text db 'Coded by bundy (c) 2oo3',13,10
	     db 13,10
	     db 'Keygen for Keygenme v1 by you_known[FCG]',13,10
	     db 'Protection ',9,': Elliptic curves !',13,10
	     db 13,10
	     db 'Greetz fly out to all reverse-engeneering-academy',13,10
	     db 'members and all at board.anticrack.de!',0

  hinstance dd ?

  base64tab db 'aAbBcCdDeEfFgGhHiIjJkKlLmMnNoOpPqQrRsStTuUvVwWxXyYzZ0123456789+='

  name rb MAXCHARS+1
  serial rb 2*MAXCHARS+1	; how many it will be ...  9/6*4/3 = 2
  temp_serial rb 2*MAXCHARS	; for each 6 bytes of serial we need 2+1 aditional bytes (2, x, 6bytes, 0)
				; but I better occupate more space 9/6 = 1,5

section '.idata' import data readable writeable

  library kernel32,'KERNEL32.DLL',\
	  user32,'USER32.DLL'

  import kernel32,\
	 GetModuleHandle,'GetModuleHandleA',\
	 ExitProcess,'ExitProcess'

  import user32,\
	 DialogBoxParam,'DialogBoxParamA',\
	 SendDlgItemMessage,'SendDlgItemMessageA',\
	 SetDlgItemText,'SetDlgItemTextA',\
	 GetDlgItemText,'GetDlgItemTextA',\
	 EndDialog,'EndDialog',\
	 MessageBox,'MessageBoxA',\
	 LoadIcon,'LoadIconA',\
	 SendMessage,'SendMessageA'

section '.rsrc' resource data readable

  directory RT_DIALOG,dialogs,\
	    RT_ICON,icons,\
	    RT_GROUP_ICON,group_icons

  resource dialogs, DLG_MAIN,LANG_ENGLISH+SUBLANG_DEFAULT,dlg_main

  dialog dlg_main, "Kgmev1 by you_known[FCG] - keygen",0, 0, 234, 84,DS_MODALFRAME+DS_3DLOOK+DS_CENTER+WS_MINIMIZEBOX+WS_CLIPSIBLINGS+WS_CAPTION+WS_SYSMENU
    dialogitem 'STATIC','Your Name:',-1,6,8,68,8,WS_VISIBLE
    dialogitem 'EDIT','',ED_NAME,6,19,220,12,ES_AUTOHSCROLL+WS_VISIBLE+WS_TABSTOP, WS_EX_STATICEDGE
    dialogitem 'STATIC','Registration Code:',-1,6,36,68,8,WS_VISIBLE
    dialogitem 'EDIT','',ED_SERIAL,6,47,220,12,ES_AUTOHSCROLL+ES_READONLY+WS_VISIBLE+WS_TABSTOP, WS_EX_STATICEDGE
if GENERATE=1
    dialogitem 'BUTTON','&Generate',BUT_GENERATE,121,64,50,14,WS_VISIBLE+WS_TABSTOP, WS_EX_STATICEDGE
end if
    dialogitem 'BUTTON','&About',BUT_ABOUT,177,64,50,14,WS_VISIBLE+WS_TABSTOP, WS_EX_STATICEDGE
    dialogitem 'STATIC','coded by bundy',-1,7,66,57,11,WS_DISABLED+WS_VISIBLE
  enddialog

  resource icons, 1,LANG_NEUTRAL,icon_data

  resource group_icons, ID_ICON,LANG_NEUTRAL,main_icon

  icon main_icon,icon_data,'keygen.ico'
